(function () {
    "use strict";

    angular.module('core').controller('operacaoVendaDetailController', controller);
    controller.$inject = ['$scope', '$timeout', 'lookupService', '$state', '$stateParams', 'operacaoVendaService', '$alert','$q'];

    function controller($scope, $timeout, lookupService, $state, $stateParams, operacaoVendaService, $alert,$q) {
        $scope.initializeLayout('Operação de Venda');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Parcelamento: 1,
            },
        };


    
        $scope.addCondicaoPagamento = function () {

            operacaoVendaService.prepareNewCondicaoPagamento($scope.state.item)
                .then(function (response) {
                if (response.Status < 0) {

                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.item = response.Data;
                }
            },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');

                });
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.save = function () {
            $scope.state.salvando = true;
            operacaoVendaService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            operacaoVendaService
                .delete({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };

        $scope.auxiliar = {
            tabelapreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tipoclienteoperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoCliente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            condicaopagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },

        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            operacaoVendaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();